import es
import playerlib
import popuplib
import cfglib
import langlib
import gamethread

config = cfglib.AddonCFG(es.getAddonPath("bhop") + "/settings.cfg")
config.text("**************************")
config.text("Addon Settings")
config.text("**************************")
config.text(" ")
config.text("*****************************************************************************")
config.text("Configuration: General Settings\n//\n//Desc : Configure the general settings")
config.text("*****************************************************************************")
speed = config.cvar("speed",   1.4, "Here you can set the number of Speed when a user is using Speedcommand")
slowspeed = config.cvar("slowspeed",   0.6, "Here you can set the number of Speed when a user is using Slowcommand")
grav  = config.cvar("grav",   0.5, "Here you can set the number of Gravity when a user is using Speedcommand")
scoutlimit  = config.cvar("scoutlimit",   4, "How many Scouts can Spawn a Player per Map")
config.write()

teleport = {}
scoutl = {}

def load():
	global text
	config.execute()
	text = langlib.Strings(es.getAddonPath("bhop") + "/strings.ini")
	es.msg("[BhopManager] Loaded")
	for userid in es.getUseridList():
		disableAutokick(userid)
	hmenu = popuplib.create("hmenu")
	hmenu.addline("BhopManager")  
	hmenu.addline("_____________________________________")
	hmenu.addline(" ")
	hmenu.addline("->1. !Scout")
	hmenu.addline("->2. !Slow")
	hmenu.addline("->3. !Fast | !Speed")
	hmenu.addline("->4. !Normal")
	hmenu.addline("->5. !Lowgrav")
	hmenu.addline("->6. !Save | !S")
	hmenu.addline("->7. !Tele | !T")
	hmenu.addline(" ")
	hmenu.addline("_____________________________________")
	hmenu.addline(" ")
	hmenu.addline("0. Close")
	hmenu.menuselect = hmenux
	
def unload():
	es.msg("[BhopManager] Unloaded")
	teleport.clear()
	scoutl.clear()
	
def es_map_start(ev):
	scoutl.clear()
	
def player_spawn(ev):
	userid = ev['userid']
	es.tell(userid, '#multi', text('spawnmessage',{},playerlib.getPlayer(userid).get('lang')))

  

def player_activate(ev):
	disableAutokick(ev['userid'])
   
def disableAutokick(userid):
	es.server.mp_disable_autokick(userid)

	
def player_say(ev):
	userid = ev['userid']
	team = es.getplayerteam(userid)
	isDeath = es.getplayerprop(userid, 'CBasePlayer.pl.deadflag')
	text1 = ev['text']
	player = playerlib.getPlayer(userid)
	if text1 in ('!bmenu','!bhop','!bhopmenu'):
		if not isDeath and team != 1:
			popuplib.send('hmenu', userid)
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	if text1 == '!scout':
		if not isDeath and team != 1:
			if not scoutl.has_key(userid):
				scoutl[userid] = 0
			if scoutl[userid] != scoutlimit:
				es.server.queuecmd('es_xgive %s %s' % (userid, "weapon_scout"))
				scoutl[userid] += 1
				es.tell(userid, '#multi', text('givescout',{},player.get('lang')))
			else:
				es.tell(userid, '#multi', text('sclimit',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	if text1 == '!slow':
		if not isDeath and team != 1:
			player.set("speed", '%s' % slowspeed)
			es.tell(userid, '#multi', text('slowspeed',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	if text1 in ('!fast','!speed'):
		if not isDeath and team != 1:
			player.set("speed", '%s' % speed)
			es.tell(userid, '#multi', text('fastspeed1',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	if text1 == '!lowgrav':
		if not isDeath and team != 1:
			es.server.queuecmd('es_fire %s !self addoutput "gravity %s"' % (userid, grav))
			es.tell(userid, '#multi', text('gravitylang',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	if text1 == '!normal':
		if not isDeath and team != 1:
			player.set("speed", 1.0)
			es.server.queuecmd('es_fire %s !self addoutput "gravity 1"' % userid)
			es.tell(userid, '#multi', text('normallang',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	if text1 in ('!save','!s'):
		if not isDeath and team != 1:
			if player.onground:
				teleport[userid] = es.getplayerlocation(userid)
				es.tell(userid, '#multi', text('savedloc',{},player.get('lang')))
			else:
				es.tell(userid, '#multi', text('onground',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	if text1 in ('!tele','!t'):
		if not isDeath and team != 1:
			if teleport.has_key(userid):
				x = teleport[userid][0]
				y = teleport[userid][1]
				z = teleport[userid][2]
				es.server.queuecmd('es_xsetpos %s %s %s %s' % (userid, x,y,z)) 
				es.tell(userid, '#multi', text('teleloc',{},player.get('lang')))
			else:
				es.tell(userid, '#multi', text('telenotloc',{},player.get('lang')))	
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))


def hmenux(userid, choice, popupid):
	team = es.getplayerteam(userid)
	isDeath = es.getplayerprop(userid, 'CBasePlayer.pl.deadflag')
	player = playerlib.getPlayer(userid)
	if choice == 1:
		if not isDeath and team != 1:
			if not scoutl.has_key(userid):
				scoutl[userid] = 0
			if scoutl[userid] != scoutlimit:
				es.server.queuecmd('es_xgive %s %s' % (userid, "weapon_scout"))
				scoutl[userid] += 1
				es.tell(userid, '#multi', text('givescout',{},player.get('lang')))
			else:
				es.tell(userid, '#multi', text('sclimit',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	elif choice == 2:
		if not isDeath and team != 1:
			player.set("speed", '%s' % slowspeed)
			es.tell(userid, '#multi', text('slowspeed',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	elif choice == 3:
		if not isDeath and team != 1:
			player.set("speed", '%s' % speed)
			es.tell(userid, '#multi', text('fastspeed1',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	elif choice == 4:
		if not isDeath and team != 1:
			player.set("speed", 1.0)
			es.server.queuecmd('es_fire %s !self addoutput "gravity 1"' % userid)
			es.tell(userid, '#multi', text('normallang',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	elif choice == 5:
		if not isDeath and team != 1:
			es.server.queuecmd('es_fire %s !self addoutput "gravity %s"' % (userid, grav))
			es.tell(userid, '#multi', text('gravitylang',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	elif choice == 6:
		if not isDeath and team != 1:
			if player.onground:
				teleport[userid] = es.getplayerlocation(userid)
				es.tell(userid, '#multi', text('savedloc',{},player.get('lang')))
			else:
				es.tell(userid, '#multi', text('onground',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
	elif choice == 7:
		if not isDeath and team != 1:
			if teleport.has_key(userid):
				x = teleport[userid][0]
				y = teleport[userid][1]
				z = teleport[userid][2]
				es.server.queuecmd('es_xsetpos %s %s %s %s' % (userid, x,y,z)) 
				es.tell(userid, '#multi', text('teleloc',{},player.get('lang')))
			else:
				es.tell(userid, '#multi', text('telenotloc',{},player.get('lang')))
		else:
			es.tell(userid, '#multi', text('notspecordeath',{},player.get('lang')))
			
def player_disconnect(ev):
	userid = ev['userid']
	if teleport.has_key(userid):
		del teleport[userid]
	if scoutl.has_key(userid):
		del scoutl[userid]

